// ENCControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ENCControl.h"
#include "ENCControlDlg.h"
#include "ENCControlConfig.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CENCControlDlg dialog

CENCControlDlg::CENCControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CENCControlDlg::IDD, pParent)
{
	
	//{{AFX_DATA_INIT(CENCControlDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
}

CENCControlDlg::~CENCControlDlg()
{
	m_pEncoder->Release();
}

void CENCControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CENCControlDlg)
	DDX_Control(pDX, IDC_PROPSHELLCTRL, m_PropShell);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CENCControlDlg, CDialog)
	//{{AFX_MSG_MAP(CENCControlDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_CONFIGURE, OnConfigure)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CENCControlDlg message handlers

BOOL CENCControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	
	IUnknown* pMainPage;
	IMSPropShell* pPropShell;
	
	m_PropShell.GetControlUnknown()->QueryInterface(IID_IMSPropShell,(void**)&pPropShell);
	HRESULT hr=CoCreateInstance(CLSID_WMEncMonMainPage,NULL,CLSCTX_INPROC_SERVER,IID_IUnknown,(void**) &pMainPage);
	HRESULT hr1=CoCreateInstance(CLSID_WMEncoder,NULL,CLSCTX_INPROC_SERVER,IID_IWMEncoder,(void**) &m_pEncoder);

	pPropShell->AddObject(m_pEncoder);
	pPropShell->AddPage(pMainPage);
	

	pMainPage->Release();
	pPropShell->Release();


	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CENCControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CENCControlDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CENCControlDlg::OnStart() 
{
	m_pEncoder->Start();
	
}

void CENCControlDlg::OnStop() 
{
	WMENC_ENCODER_STATE EncoderState;
	m_pEncoder->get_RunState(&EncoderState);
	//TCHAR szBuffer[64];
	//wsprintf( szBuffer, _T("%d"), EncoderState ); 
	//AfxMessageBox(szBuffer);
	if ((EncoderState==WMENC_ENCODER_RUNNING)||(EncoderState==WMENC_ENCODER_PAUSED)){
		
		m_pEncoder->Stop();	
	}
	
}

void CENCControlDlg::OnConfigure() 
{
	ENCControlConfig ConfigDlg;
	ConfigDlg.SetEncoder(m_pEncoder);
	ConfigDlg.DoModal();
}
